﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Zcu.CurvatureBenchmark.Framework;
using Zcu.CurvatureBenchmark.Framework.DataSources.Explicit;

namespace Zcu.CurvatureBenchmark.DataSources
{
    /// <summary>
    /// Does not produce any triangles - for DataSource debugging only!
    /// </summary>
    internal class DummyTriangularizator : AbstractModule, IExplicitTriangularizator
    {
        /// <inheritdoc/>
        public void Triangulate(IExplicitSampler sampler)
        {
            TriangleMesh = new TriangleMesh();
            TriangleMesh.ExactK1 = sampler.K1;
            TriangleMesh.ExactK2 = sampler.K2;
            TriangleMesh.Normals = sampler.Normals;
            TriangleMesh.Points = sampler.Points;
        }

        /// <inheritdoc/>
        public TriangleMesh TriangleMesh {get; private set;}
    }
}
