﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Zcu.CurvatureBenchmark.Framework;

namespace Zcu.CurvatureBenchmark.DataSources.Implicit
{
    public class DegeneratedTriangularizator : AbstractModule, IImplicitTriangularizator
    {
        public void Triangulate(IImplicitSampler sampler)
        {
            TriangleMesh = new TriangleMesh();
            TriangleMesh.Normals = sampler.Normals;
            TriangleMesh.Points = sampler.Points;
            TriangleMesh.ExactK1 = sampler.K1;
            TriangleMesh.ExactK2 = sampler.K2;
            TriangleMesh.Triangles = new Triangle[sampler.Points.Length];
            for (int i = 0; i < TriangleMesh.Points.Length; i++)
            {
                TriangleMesh.Triangles[i] = new Triangle(i, i, i);
            }            
        }

        public TriangleMesh TriangleMesh {get; private set;}
    }
}
