﻿/*
 * This is free and unencumbered software released into the public domain.
 *
 * Anyone is free to copy, modify, publish, use, compile, sell, or
 * distribute this software, either in source code form or as a compiled
 * binary, for any purpose, commercial or non-commercial, and by any
 * means.
 *
 * In jurisdictions that recognize copyright laws, the author or authors
 * of this software dedicate any and all copyright interest in the
 * software to the public domain. We make this dedication for the benefit
 * of the public at large and to the detriment of our heirs and
 * successors. We intend this dedication to be an overt act of
 * relinquishment in perpetuity of all present and future rights to this
 * software under copyright law.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * For more information, please refer to <http://unlicense.org/>
 */

/*
 * https://github.com/tuckbone/DualContouringCSharp
 * 
 * Please do not use this code as the "Ideal way to code in C#"!!! 
 * It is by no means optimized for managed code. This is nothing but a direct port 
 * of NGildea's Dual Contouring Impl from his blog.
 * 
 */
internal class SMat3
    {
        public double m00, m01, m02, m11, m12, m22;

        public SMat3()
        { 
            clear();
        }

        public SMat3(double m00, double m01, double m02, double m11, double m12, double m22)
        { 
            this.setSymmetric(m00, m01, m02, m11, m12, m22);
        }

        public void clear() 
        {
            this.setSymmetric(0, 0, 0, 0, 0, 0); 
        }

        public void setSymmetric(double a00, double a01, double a02, double a11, double a12, double a22)
        {
            this.m00 = a00;
            this.m01 = a01;
            this.m02 = a02;
            this.m11 = a11;
            this.m12 = a12;
            this.m22 = a22;
        }

        public void setSymmetric(SMat3 rhs)
        {
            this.setSymmetric(rhs.m00, rhs.m01, rhs.m02, rhs.m11, rhs.m12, rhs.m22);
        }

        private SMat3(SMat3 rhs) 
        { 
            this.setSymmetric(rhs);
        }
    }