﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Zcu.CurvatureBenchmark.Framework;

namespace Zcu.CurvatureBenchmark.Distorters
{
    public class NormalsGouraudCP : AbstractDistorter
    {
        public override TriangleMesh Distort(TriangleMesh input)
        {
            CornerTable ct = new CornerTable(input);
            Point3D[] newNormals = new Point3D[input.Points.Length];
            foreach (Triangle t in input.Triangles)
            {

                Point3D v1 = Point3D.Subtract(input.Points[t.V2], input.Points[t.V1]);
                Point3D v2 = Point3D.Subtract(input.Points[t.V3], input.Points[t.V1]);
                Point3D v3 = Point3D.Subtract(input.Points[t.V3], input.Points[t.V2]);
                Point3D cp = v2.CrossProduct(v1);

                newNormals[t.V1] += cp;
                newNormals[t.V2] += cp;
                newNormals[t.V3] += cp;
            }


            for (int i = 0; i < newNormals.Length; i++)
            {
                double n = ct.VF(i).Length;
                newNormals[i] = (newNormals[i]/n).Normalize();
            }
            TriangleMesh result = input.ShallowCopy();
            result.Normals = newNormals;
            return result;
        }
    }
}
