﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Zcu.CurvatureBenchmark.Framework;
using Zcu.CurvatureBenchmark.Framework.Estimators;
using Zcu.CurvatureBenchmark.Framework.Evaluators;


namespace Zcu.CurvatureBenchmark.Evaluators
{
    [Obsolete()]
    internal  class NormalEvaluatorPearson : AbstractEvaluator
    {
        Point3D[] exactNormals = null;

        public NormalEvaluatorPearson()
        {
            excludeBorderTopological = false;
            excludeBorderGeometric = false;
            topologicalExclusionZone = 1;
            geometricExclusionZone = 0.0;
        }

        /// <inheritdoc/>
        public override Dictionary<string, object> Evaluate(TriangleMesh mesh, ICurvatureEstimator estimator)
        {
            if (newDatasetComming)
            {
                exactNormals = mesh.Normals;
                newDatasetComming = false;
                return new Dictionary<string, object>() { { "avgDP", 0 } };
            }
            else
            {
                SetExclusionZone(mesh);
                double avgDP = 0;
                for (int i = 0;i<mesh.Normals.Length;i++)
                {
                    if (excluded[i])
                        continue;
                    Point3D n1 = mesh.Normals[i];
                    double x1 =(n1.X+n1.Y+n1.Z)/i; //stredni hodnota
                    Point3D xd1 = n1 - x1; //uprava Point3D

                    Point3D n2 = exactNormals[i];
                    double x2 = (n2.X + n2.Y + n2.Z) / i; //stredni hodnota
                    Point3D xd2 = n2 - x2; //uprava Point3D

                    avgDP += (xd1.X * xd2.X + xd1.Y * xd2.Y + xd1.Z * xd2.Z);

                }
                avgDP /= exactNormals.Length;
                return new Dictionary<string, object>() { { "avgDP", avgDP } };
            }
        }

        bool newDatasetComming = true;

        /*public override void NewDataset()
        {
            base.NewDataset();
            newDatasetComming = true;
        }*/
    }
}