﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace Zcu.CurvatureBenchmark.Framework.DataSources
{
    /// <summary>
    /// Module for data source. The module generates a set of triangle meshes.
    /// </summary>
    public interface IDataSource : IModule
    {		
        /// <summary>
        /// Generates a set of inputs, depending on the state
        /// </summary>
        /// <returns>Set of triangle meshes</returns>
        TriangleMesh[] GenerateData();

        /// <summary>
        /// Gets/sets the number of generated triangle meshes. This property is used with data sources that can produce multiple
        /// data usually based on randomization.
        /// </summary>
        int DatasetCount
        {
            get; set;
        }
		
    }
}
