﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace Zcu.CurvatureBenchmark.Framework.Estimators
{
    /// <summary>
    /// Abstract implementation of <see cref="ICurvatureEstimator"/> has the basic functionality of abstract module <see cref="AbstractModule"/>. 
    /// Derived classes must implement the EstimateCurvatures method.
    /// </summary>
    public abstract class AbstractEstimator : AbstractModule, ICurvatureEstimator
    {
        /// <inheritdoc/>
        public abstract double[] K1 { get; }

        /// <inheritdoc/>
        public abstract double[] K2 { get; }


        /// <inheritdoc/>
        public virtual int RunningTime
        {
            get { return -1; }
        }

        /// <inheritdoc/>
        abstract public void EstimateCurvatures(TriangleMesh mesh);

        /// <inheritdoc/>
        public virtual ICurvatureEstimator ShallowCopy()
        {
            return (ICurvatureEstimator)this.MemberwiseClone();
        }

    }
}
