﻿
namespace Zcu.CurvatureBenchmark.Framework.Estimators
{
    /// <summary>
    /// This is not real estimator, it just pass exact curvature.
    /// </summary>
    public class ExactEstimator : AbstractEstimator
    {
        double[] k1, k2;

        /// <inheritdoc/>
        override public double[] K1
        {
            get { return k1; }
        }

        /// <inheritdoc/>
        override public double[] K2
        {
            get { return k2; }
        }

        /// <inheritdoc/>
        override public void EstimateCurvatures(TriangleMesh mesh)
        {
            k1 = (double[])mesh.ExactK1.Clone();
            k2 = (double[])mesh.ExactK2.Clone();
        }
    };
}
