﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Zcu.CurvatureBenchmark.Framework
{
    /// <summary>
    /// Simple off saver (no color information).
    /// </summary>
    public class OFFSaver
    {

        string fileName = "out.off";

        /// <summary>
        /// Filename (default out.off)
        /// </summary>
        public string FileName
        {
            get { return fileName; }
            set { fileName = value; }
        }

        /// <summary>
        /// Writes triangle mesh to a file.
        /// </summary>
        /// <param name="mesh">Mesh</param>
        public void Execute(TriangleMesh mesh)
        {
            System.Globalization.NumberFormatInfo nfi = new System.Globalization.NumberFormatInfo();
            nfi.NumberDecimalSeparator = ".";

            Triangle[] triangles = mesh.Triangles;

            StreamWriter sw = new StreamWriter(fileName);
            sw.WriteLine("OFF");
            sw.WriteLine(mesh.Points.Length.ToString() + " " + triangles.Length.ToString() + " 0");
            for (int i = 0; i < mesh.Points.Length; i++)
            {
                Point3D p = (Point3D)mesh.Points[i];
                sw.WriteLine(p.X.ToString(nfi) + " " + p.Y.ToString(nfi) + " " + p.Z.ToString(nfi));
            }

            for (int i = 0; i < triangles.Length; i++)
            {
                Triangle t = (Triangle)triangles[i];
                sw.WriteLine("3 " + t.V1.ToString() + " " + t.V2.ToString() +" " + t.V3.ToString());
            }
            sw.Close();
        }
    }
}
