﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Zcu.CurvatureBenchmark.Framework
{
    /// <summary>
    /// Represents triangle with vertices given by indices in vertex array.
    /// </summary>
    public struct Triangle
    {
        //public static readonly int VERTICES_COUNT = 3;

        /// <summary>
        /// Index of vertex 1
        /// </summary>
        public int V1;

        /// <summary>
        /// Index of vertex 2
        /// </summary>
        public int V2;

        /// <summary>
        /// Index of vertex 3
        /// </summary>
        public int V3;


        /// <summary>
        /// Triangle vertex indexer. Try to avoid the indexer due to performance hit.
        /// </summary>
        /// <param name="i">Triangle vertex</param>
        /// <returns>Index of vertex or -1</returns>
        [Obsolete("Try to avoid this indexer. Possible performance hit.")]
        public int this[int i]
        {
            get 
            {
                switch (i) 
                {
                    case 0: return V1;
                    case 1: return V2;
                    case 2: return V3;
                    default: break;
                }
                return -1;
            }
            set
            {
                switch (i)
                {
                    case 0: V1 = value; break;
                    case 1: V2 = value; break;
                    case 2: V3 = value; break;
                    default: break;
                }                
            }

        }

        /// <summary>
        /// Create triangle with vertices on index v1, v2, v3
        /// </summary>
        /// <param name="v1">Index of vertex 1</param>
        /// <param name="v2">Index of vertex 2</param>
        /// <param name="v3">Index of vertex 3</param>
        public Triangle(int v1, int v2, int v3)
        {
            V1 = v1;
            V2 = v2;
            V3 = v3;
        }
    }    
}
