﻿using System;
using SlimDX;

namespace SlimDXRenderSystem.Core
{
    public class Light
    {
        private String name;
        private LightStruct light;
        private LightType type;

        public String Name
        {
            get { return name; }
            set { name = value; }
        }

        public Vector3 Direction
        {
            get { return light.Direction; }
            set { light.Direction = value; }
        }

        public Vector3 Position
        {
            get { return light.Position; }
            set { light.Position = value; }
        }

        public Vector4 Ambient
        {
            get { return light.Ambient; }
            set { light.Ambient = value; }
        }

        public Vector4 Diffuse
        {
            get { return light.Diffuse; }
            set { light.Diffuse = value; }
        }

        public Vector4 Specular
        {
            get { return light.Specular; }
            set { light.Specular = value; }
        }

        public float SpotInnerCone
        {
            get { return light.SpotInnerCone; }
            set { light.SpotInnerCone = value; }
        }

        public float SpotOuterCone
        {
            get { return light.SpotOuterCone; }
            set { light.SpotOuterCone = value; }
        }

        public float Radius
        {
            get { return light.Radius; }
            set { light.Radius = value; }
        }

        public LightType Type
        {
            get { return type; }
            set { type = value; }
        }

        public LightStruct LightStruct
        {
            get { return light; }
        }

        public Light(string name)
        {
            this.name = name;
            light = new LightStruct();
            type = LightType.Directional;
        }
    }
}
