﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Zcu.CurvatureBenchmark.Framework;

namespace Zcu.Mve.ZMalik.SlimDXRenderer
{
    public class Object3DPointAttribs
    {
        Object3D parent;
        public Object3DPointAttribs(Object3D parent)
        {
            this.parent = parent;
        }

        int index;
        public int Index
        {
            get { return index; }
            set { index = value; }
        }

        [Category("Coordinates")]
        public double X { get { return parent.Points[index].X; } }
        [Category("Coordinates")]
        public double Y { get { return parent.Points[index].Y; } }
        [Category("Coordinates")]
        public double Z { get { return parent.Points[index].Z; } }

        [Category("Normal")]
        public double nX { get { return parent.Normals[index].X; } }
        [Category("Normal")]
        public double nY { get { return parent.Normals[index].Y; } }
        [Category("Normal")]
        public double nZ { get { return parent.Normals[index].Z; } }

        [Category("Curvature")]
        public double K1 { get { if (parent.Estimator != null) return parent.Estimator.K1[index]; return double.NaN; } }
        [Category("Curvature")]
        public double K2 { get { if (parent.Estimator != null) return parent.Estimator.K2[index]; return double.NaN; } }
        [Category("Curvature")]
        public double Mean { get { if (parent.Estimator != null) return (parent.Estimator.K1[index]+ parent.Estimator.K2[index])/2; return double.NaN; } }
        [Category("Curvature")]
        public double Gaussian { get { if (parent.Estimator != null) return (parent.Estimator.K1[index] * parent.Estimator.K2[index]); return double.NaN; } }

        double minK1 = double.NaN;
        [Category("MinCurvature")]
        public double MinK1
        {
            get
            {
                if (double.IsNaN(minK1))
                    if (parent.Estimator != null) minK1 = parent.Estimator.K1.Min();
                return minK1;
            }
        }

        double minK2 = double.NaN;
        [Category("MinCurvature")]
        public double MinK2
        {
            get
            {
                if (double.IsNaN(minK2))
                    if (parent.Estimator != null) minK2 = parent.Estimator.K2.Min();
                return minK2;
            }
        }

        double maxK1 = double.NaN;
        [Category("MaxCurvature")]
        public double MaxK1
        {
            get
            {
                if (double.IsNaN(maxK1))
                    if (parent.Estimator != null) maxK1 = parent.Estimator.K1.Max();
                return maxK1;
            }
        }

        double maxK2 = double.NaN;
        [Category("MaxCurvature")]
        public double MaxK2
        {
            get
            {
                if (double.IsNaN(maxK2))
                    if (parent.Estimator != null) maxK2 = parent.Estimator.K2.Max();
                return maxK2;
            }
        }


    }
}
